package com.sun.security.sasl;

import javax.security.sasl.SaslException;
import com.sun.security.sasl.util.PolicyUtils;
import javax.security.sasl.SaslServer;
import javax.security.auth.callback.CallbackHandler;
import java.util.Map;
import javax.security.sasl.SaslServerFactory;

public final class ServerFactoryImpl implements SaslServerFactory
{
    private static final String[] myMechs;
    private static final int[] mechPolicies;
    private static final int CRAMMD5 = 0;
    
    public ServerFactoryImpl() {
    }
    
    @Override
    public SaslServer createSaslServer(String s, String s2, String s3, Map<String, ?> props, CallbackHandler callbackHandler) throws SaslException {
        if (s.equals(ServerFactoryImpl.myMechs[0]) && PolicyUtils.checkPolicy(ServerFactoryImpl.mechPolicies[0], props)) {
            if (callbackHandler == null) {
                throw new SaslException("Callback handler with support for AuthorizeCallback required");
            }
            return new CramMD5Server(s2, s3, props, callbackHandler);
        }
        else {
            return null;
        }
    }
    
    @Override
    public String[] getMechanismNames(Map<String, ?> props) {
        return PolicyUtils.filterMechs(ServerFactoryImpl.myMechs, ServerFactoryImpl.mechPolicies, props);
    }
    
    static {
        myMechs = new String[] { "CRAM-MD5" };
        mechPolicies = new int[] { 17 };
    }
}
